/* Code developed for DvCon 2010 
 By Ben Cohen, Srinivasan Venkataramanan, Ajeetha Kumari, and Lisa Piper
 "SystemVerilog Assertions Handbook, 2nd edition"ISBN  878-0-9705394-8-7
  www.systemverilog.us  ben@systemverilog.us
  www.cvcblr.com, info@cvcblr.com

 All code provided in this presentation is distributed
 with *ABSOLUTELY NO SUPPORT* and *NO WARRANTY* from the authors.  
*/
checker chk_rd_wr_cntlr(
 //user interface
   logic busy,  
   logic rd, wr,
   logic  [MAIN_MEM_ADDRESS_WIDTH-1:0] addr,                     
   logic [MEM_DATA_WIDTH-1:0]         rd_data, 
   logic  [MEM_DATA_WIDTH-1:0]         wr_data,  
  // clock and resets 
   event clk, 
   logic rst_n);

	  // never a simulataneous rd and wr
		 ap_never_rd_wr: assert #0 (! (rd && wr));

    let cs = rd || wr;  // demonstrates the equivalency of this signal
    mp_no_simultaneous_rd_wr: assume property (
     @clk not (rd && wr));

    mp_busy_no_rd_wr: assume property (
            @clk busy |-> !rd && !wr);

  property p_wr_rd;
    int v_addr, v_data;
      first_match(($rose(wr), v_addr=addr, v_data=wr_data) ##1 
      !(wr && addr==v_addr)[*1:$] ##1 rd && addr==v_addr) |->
                                   ##[1:MEM_CYCLES] rd_data==v_data;
  endproperty : p_wr_rd
  ap_wr_rd : assert property(@clk p_wr_rd);



endchecker : chk_rd_wr_cntlr
